
function _startFunctionAfter( func, delay ) {
//	// console.log( 'start function after ' + delay);
	timer = func.timer;
	if( timer == null || timer == undefined ) {
		func.timer = setTimeout( func, delay);
	}
}

function _restartFunctionAfter( func, delay ) {
//	// console.log( 'restart function after ' + delay);
	timer = func.timer;
	if( timer != null && timer != undefined ) {
		clearTimeout(timer);
		func.timer = null;
	}
	func.timer = setTimeout( func, delay);
}

function _clearFunctionTimer( func ) {
	
//	// console.log( 'clear function timer' );
	timer = func.timer;
	if( timer != null && timer != undefined ) {
		clearTimeout(timer);
		func.timer = null;
	}
}

function _docViewPort() {

    docHeight = _docView.offsetHeight;
    docBottom = parseFloat(_docView.style.bottom,10);
    
    height = _scrollView.offsetHeight;
    docY = docBottom+docHeight-height;
    
    var v =  { y : docY, height: height };
    return v;
}

function _showLazyImage(div) {

//    // console.log("_show lazy image");

    src = div.dataset.src;

//    while(div.lastChild != null) { div.removeChild(div.lastChild); }
    img = div.getElementsByTagName('IMG')[0];
    
    div.className = 'msg_attachment_photo_loading';
    
//    img = document.createElement('IMG');

    img.src = src;
    img.onload= function() { _clearImgPlaceholder(this); };
    img.onclick= function() { _showImage(this); };
    
//    div.appendChild(img);
    
}

function _divY(elm) {

    var test = elm, top = 0;
    while( test && test != _docView ) {
        top += test.offsetTop;
        test = test.offsetParent;
    }

    return top;
}

function _loadLazyImages() {

//    // console.log("_load lazy images");

    viewPort = _docViewPort();
    y = viewPort.y;
    height = viewPort.height;
    end = y + height;
    
    lazyImages = document.getElementsByClassName('msg_attachment_photo_lazy');
    count = lazyImages.length;
    
//    // console.log( "view port {" + y + " , " + end + " }" );
//    // console.log( count + " lazy images");
    
    for( i = count-1; i >=0; i-- ) {
        div = lazyImages[i];
        divY = _divY(div);
        divEnd = divY + div.offsetHeight;
        
//        // console.log("check div {"+ divY +" , " + divEnd + " }" );

        if( ( divY > y && divY < end ) ||
            ( divEnd > y && divEnd < end )
        ) {
            // load the image
            _showLazyImage(div);
        }
    }

}

function _getCSSRule(ruleName) {               // Return requested style obejct
   ruleName=ruleName.toLowerCase();                       // Convert test string to lower case.
   if (document.styleSheets) {                            // If browser can play with stylesheets
      for (var i=0; i<document.styleSheets.length; i++) { // For each stylesheet
         var styleSheet=document.styleSheets[i];          // Get the current Stylesheet
         var cssRule=false;                               // Initialize cssRule.
         var rules = styleSheet.cssRules;
         if( null != rules && rules.length ) {
             var ii= rules.length-1;                                        // Initialize subCounter.
	         do {                                             // For each rule in stylesheet
             
	            cssRule = rules[ii];         // Yes --Mozilla Style
	            if (cssRule)  {                               // If we found a rule...
	               if (cssRule.selectorText.toLowerCase()==ruleName) { //  match ruleName?
	                   return cssRule;                      // return the style object.
	               }                                          // End found rule name
	            }                                             // end found cssRule
	            ii--;                                         // Increment sub-counter
	         } while (cssRule);                                // end While loop
         }
      }                                                   // end For loop
   }                                                      // end styleSheet ability check
   return false;                                          // we found NOTHING!
}

function _updateMaxMsgBodyWidth() {
//	// console.log('_updateMaxMsgBodyWidth');
	if( null == _msgBodyCSS ) {
		_msgBodyCSS = _getCSSRule('.msg_body');
	}
    style = _msgBodyCSS.style;
    if( undefined != style && null != style ) {
        v = style.getPropertyValue('max-width');
        w = window.innerWidth - 140;
        style.setProperty('max-width', w+'px', style.getPropertyPriority('width'));
    }
}

var _wheelDistance = function(evt){
  if (!evt) evt = event;
  var w=evt.wheelDelta;
  return w/13;
};


function _scrollChatContentEvent(event) {

	_clearFunctionTimer(_loadLazyImages);

	speed = _wheelDistance(event);
    
    _scrollSpeed = _scrollSpeed/2+speed;
    
	direction = _scrollDirection(_scrollSpeed);
	style = _docView.style;
    knobStyle = _scrollBarKnob.style;
	
	docH = _docView.scrollHeight;
	vH = _scrollView.offsetHeight;
	
	if( docH < vH ) {
		if( style.bottom != '0px' ) {
			style.bottom = '0px';
            knobStyle.bottom = '0px';
		}
		return;
	}

	if( _docView.className == 'scroll_animation' ) {
		if( direction != _previouseScrollDirection ) {
			// stop
            _cleanupScrollViewAni();
    
		}
        return;
	}
	
	_clearFunctionTimer(_cleanupScrollViewAni);
	
	vstr = style.bottom;
	pos = parseFloat(vstr,10);
	newPos = pos - _scrollSpeed;
    
	_previouseScrollDirection = direction;
	
	if( newPos > 40 ) {
		
//		_docView.className = 'scroll_animation';
		style.bottom = '0px';
        knobStyle.bottom = '0px';
        _scrollSpeed = 0;
		
	} else {

		if( vH-newPos > docH+40 ) {
				
			_docView.className = 'scroll_animation';
            newPos = vH-docH;
			APP.loadMoreMessages();
            
            _scrollSpeed = 0;
		}
        
        if( newPos > 0 ) {
            newPos = 0;
        }
        
        style.bottom = Math.floor(newPos)+'px';
        
        percent = -(newPos/(docH-vH));
        knobStyle.bottom = Math.floor(percent*(vH-_scrollBarKnob.offsetHeight))+'px';
        
        if( _scrollBar.className != 'fcom_chat_scrollbar scrolling' ) {
            _scrollBar.className = 'fcom_chat_scrollbar scrolling';
        }
        
	}
    
    _startFunctionAfter( _cleanupScrollViewAni, 900 );
}

function _scrollDirection(delta) {
	if( delta < 0 ) { return -1; }
	if( delta > 0 ) { return 1; }
	return 0;
}

function _cleanupScrollViewAni() {

//    // console.log("_cleanup scroll view ani");
	_clearFunctionTimer( _cleanupScrollViewAni );
	
	_docView.className = '';
	_previouseScrollDirection = 0;
    _scrollSpeed = 0;
    
    if( _scrollBar.className != 'fcom_chat_scrollbar' ) {
        _scrollBar.className = 'fcom_chat_scrollbar';
    }
    
    // check visible lazy images
    _loadLazyImages();
	
}

function _chatDocviewResized() {

	docH = _docView.scrollHeight;
	vH = _scrollView.offsetHeight;
    
    knobHeight = Math.floor((vH/docH)*vH);
    _scrollBarKnob.style.height = knobHeight+'px';
    
//    // console.log('change knob size to '+knobHeight);

}

function _scrollbar_move_knob(e) {

    startY = e.clientY;
    vH =  _scrollBar.offsetHeight;
    docH = _docView.offsetHeight;
    knobHeight = _scrollBarKnob.offsetHeight;
    knobR = knobHeight/2;
    
//    // console.log('y: '+startY+' vH: '+vH+' docH: '+docH+' knobR: '+knobR);

    bottom = vH-startY-knobR;
    
    maxBottom = vH-knobHeight;
    if( bottom > maxBottom ) {
        bottom = maxBottom;
    } else if( bottom < 0 ) {
        bottom = 0;
    }    
    
    // move the knob to postion
    _scrollBarKnob.style.bottom = bottom +'px';
    
    y = startY-knobR;
    docY = y*(docH-vH)/(vH-knobHeight);
//    // console.log('page start at: '+docY);
    
    newPos = Math.floor(vH+docY-docH);
//    // console.log('new pos: '+newPos);
    
    total = docH-vH;
    if( newPos > 0 ) {
        newPos = 0;
    } else if( newPos < vH-docH ) {
        newPos = vH-docH;
    }
    
    _docView.style.bottom = newPos + 'px';

}

function _scrollbar_mousedown(e) {

    if( _docView.offsetHeight <= _scrollView.offsetHeight ) {
        return;
    }

    _scrollbar_move_knob(e);
    
    _scrollBar.className = 'fcom_chat_scrollbar dragging';

    document.onmousemove = _scrollbar_mousemove;
    document.onmouseup = _scrollbar_mouseup;
    
    // cancel out any text selections
    document.body.focus();
    // prevent text selection in IE
    document.onselectstart = function () { return false; };

}

function _scrollbar_mouseup(e) {

    _scrollBar.className = 'fcom_chat_scrollbar';
    
    // check doc positon for requesting more 

    vH =  _scrollBar.offsetHeight;
    docH = _docView.offsetHeight;
    vstr = _docView.style.bottom;
	pos = parseFloat(vstr,10);
    
    if( Math.abs(vH-pos-docH) < 20 ) {
        APP.loadMoreMessages();
    }
    
    document.onmousemove = null;
    document.onmouseup = null;
    document.onselectstart = null;
    
}

function _scrollbar_mousemove(e) {
    _scrollbar_move_knob(e);
}


function _conversationListChanged() {
	
//    // console.log("_conversationListChanged");
	_restartFunctionAfter(_loadLazyImages,23);
	_restartFunctionAfter(_checkNewMessage,17);
	
}

function _isLastPageVisible() {

	
	// console.log('_isLastPageVisible');
	
	y = parseFloat(_docView.style.bottom,10);
	height = _scrollView.offsetHeight;
	
	// console.log('y: ' + y);
	// console.log('h: ' + height);
	
	if( y > -height ) {
		// console.log('visible');
		return true;
	}
	// console.log('not visible');
	return false;
}

function _checkNewMessage() {

    // console.log("_checkNewMessage");
	
	last = _conversationList.lastElementChild;
	if( last != _prevLast ) {
	
		// console.log("new li");
	
		if( last.previousSibling == _prevLast && _isLastPageVisible() ) {
			_scrollToMakeMessageVisible(last);
		} else {
			// there is new message
			_adjustScrollOffsetForMessageChange(last);
		}
		
		_prevLast = last;
	}
	
}

function _scrollToMakeMessageVisible(msg) {
	
	// console.log('_scrollToMakeMessageVisible');
		
	viewPort = _docViewPort();
	y = viewPort.y;
	height = viewPort.height;
	end = y + height;
	    
	msgY = _divY(msg);
//	msgEnd = msgY + msg.offsetHeight;
	    
//    // console.log( "view port {" + y + " , " + end + " }" );
//    // console.log("check msg {"+ msgY +" , " + msgEnd + " }" );
	    
	if( msgY < y || msgY > end ) {
	    
		style = _docView.style;
		newPos = _scrollView.offsetHeight - msg.offsetHeight -60;
		if( newPos > 0 ) {
			newPos = 0;
		}
	
//		// console.log("bottom " + newPos);
	
		style.bottom = newPos + 'px';
	
	}	
}

function _adjustScrollOffsetForMessageChange(msg) {

	// console.log('_adjustScrollOffsetForMessageChange');

    viewPort = _docViewPort();
    y = viewPort.y;
    height = viewPort.height;
    end = y + height;
    
    msgY = _divY(msg);
    msgEnd = msgY + msg.offsetHeight;
    
//    // console.log( "view port {" + y + " , " + end + " }" );
//    // console.log("check msg {"+ msgY +" , " + msgEnd + " }" );

    if( msgY < y && msgEnd > y && msgEnd < end ) {
    	// adjust content to show the image from the begnning
//    	// console.log('adjust content');
    
    	style = _docView.style;
		vstr = style.bottom;
    	pos = parseFloat(vstr,10);
    	newPos = pos - (y-msgY) - 20;
    	style.bottom = newPos + 'px';    		
    }
}

function _clearImgPlaceholder(img) {

//    // console.log("_clearImgPlaceholder");

	img.parentElement.className = "msg_attachment_photo";
    
    msg = img;
	while( _docView != msg && !msg.classList.contains('msg') ) {
		msg = msg.parentElement;
	};
	
    setTimeout( function() {
        // check if body is at bottom
        if( _prevLast == msg || _docView.style.bottom != '0px' ) {
            _adjustScrollOffsetForMessageChange(msg);
        }
        
    }, 23);
    setTimeout( function() { img.style.visibility = 'visible'; }, 1000);
    
}

function _showImage(img) {
    APP.showImage(img.src);
}

function _showAllParticipants() {
	
//	// console.log("show participants");
		
	style = _participants.style;
	
	if( _participants.childNodes.length > 1 && 
		style.visibility == 'hidden') {
		style.visibility = 'visible';
	}
	
	_startFunctionAfter( _exitParticipants, 5000 );
	
}

function _exitParticipants() {

//	// console.log("exit participants");

	style = _participants.style;
	
	if( style.visibility == 'visible' ) {
		style.visibility = 'hidden';
	}
	
}

window.onresize = function() {
    _updateMaxMsgBodyWidth();
    _chatDocviewResized();
};

_updateMaxMsgBodyWidth();

var _previouseScrollDirection = 0;
var _scrollSpeed = 0;

var _receipts = document.getElementById('fcom_chat_read_receipt');
var _participants = document.getElementById('fcom_participants'); 
var _scrollView = document.getElementById('fcom_chat_scrollview'); 
var _docView = document.getElementById('fcom_chat_docview');
var _msgBodyCSS = _getCSSRule('.msg_body');
_scrollBar = document.getElementsByClassName('fcom_chat_scrollbar')[0];
_scrollBarKnob = document.getElementsByClassName('fcom_chat_scrollbar_knob')[0];

var _conversationList = document.getElementById('fcom_chat_content_list');
var _prevLast = null; // _conversationList.lastElementChild;

_conversationList.addEventListener ('DOMSubtreeModified', _conversationListChanged, false);
_scrollBar.onmousedown = _scrollbar_mousedown;

_scrollView.addEventListener('mousewheel',function(event){
    _scrollChatContentEvent(event);
    event.preventDefault();
}, false);

function _participants_OnMouseOut(event) {
    //this is the original element the event handler was assigned to
    var e = event.toElement || event.relatedTarget;
    while( e != null ) {
    	if( e == this ) {
    		_restartFunctionAfter( _exitParticipants, 3000 );
    		return;
    	}
    	e = e.parentNode;
    }
	
	_clearFunctionTimer( _exitParticipants );
    _exitParticipants();
}

_receipts.addEventListener('mouseover', function() { _startFunctionAfter( _showAllParticipants, 500 ); }, true);
_receipts.addEventListener('mouseout', function() { _clearFunctionTimer( _showAllParticipants ); }, true);
_participants.addEventListener('mouseout',_participants_OnMouseOut,true);
_participants.addEventListener('mouseover', function() { _restartFunctionAfter( _exitParticipants, 3000); }, true);
